Index: trunk/src/libctests/glibc/Makefile
===================================================================
--- trunk/src/libctests/glibc/Makefile	(revision 2045)
+++ trunk/src/libctests/glibc/Makefile	(revision 2046)
@@ -51,9 +51,26 @@
 ifeq ($(TARGET),bsd)
 SKIPPED    := \
+	argp/tst-argp1.c \
+	argp/argp-test.c \
+	\
+	assert/test-assert-perr.c \
+	\
+	crypt/cert.c \
+	\
+	iconv/tst-iconv1.c \
+	iconv/tst-iconv2.c \
+	iconv/tst-iconv3.c \
+	iconv/tst-iconv5.c \
+	\
+	inet/tst-ether_aton.c \
+	\
+	intl/tst-ngettext.c \
+	\
 	string/test-mempcpy.c \
 	string/test-stpncpy.c \
 	string/tst-bswap.c \
 	string/tst-strfry.c
-EXCEPTIONS := 
+EXCEPTIONS := \
+	catgets/test-gencat.c 
 _TARGET_OK := ok
 CFLAGS     += -I sysdeps/unix/bsd -D__BSD__
@@ -618,4 +635,7 @@
 	@echo "* SKIPPING : $1"
 	@echo "SKIPPED" > $$@
+	
+_TESTS += $(OUTDIR)/$2.result
+$(eval _$(TEST) += $(OUTDIR)/$2.result)
 endef
 
Index: trunk/src/libctests/glibc/crypt/cert.c
===================================================================
--- trunk/src/libctests/glibc/crypt/cert.c	(revision 2045)
+++ trunk/src/libctests/glibc/crypt/cert.c	(revision 2046)
@@ -9,5 +9,9 @@
 #include <stdio.h>
 #include <stdlib.h>
+#ifdef __BSD__
+#include <unistd.h>
+#else
 #include "crypt.h"
+#endif 
 
 int totfails = 0;
Index: trunk/src/libctests/glibc/crypt/md5c-test.c
===================================================================
--- trunk/src/libctests/glibc/crypt/md5c-test.c	(revision 2045)
+++ trunk/src/libctests/glibc/crypt/md5c-test.c	(revision 2046)
@@ -1,3 +1,7 @@
+#ifdef __BSD__
+#include <unistd.h>
+#else
 #include <crypt.h>
+#endif 
 #include <string.h>
 
Index: trunk/src/libctests/glibc/dirent/opendir-tst1.c
===================================================================
--- trunk/src/libctests/glibc/dirent/opendir-tst1.c	(revision 2045)
+++ trunk/src/libctests/glibc/dirent/opendir-tst1.c	(revision 2046)
@@ -25,4 +25,7 @@
 #include <string.h>
 #include <unistd.h>
+#ifdef __BSD__
+#include <sys/stat.h>
+#endif 
 
 /* Name of the FIFO.  */
Index: trunk/src/libctests/glibc/inet/bug-if1.c
===================================================================
--- trunk/src/libctests/glibc/inet/bug-if1.c	(revision 2045)
+++ trunk/src/libctests/glibc/inet/bug-if1.c	(revision 2046)
@@ -22,4 +22,8 @@
 #include <stdio.h>
 #include <string.h>
+#ifdef __BSD__
+# include <sys/types.h>
+# include <sys/socket.h>
+#endif 
 #include <net/if.h>
 
Index: trunk/src/libctests/glibc/inet/htontest.c
===================================================================
--- trunk/src/libctests/glibc/inet/htontest.c	(revision 2045)
+++ trunk/src/libctests/glibc/inet/htontest.c	(revision 2046)
@@ -19,5 +19,7 @@
    02111-1307 USA.  */
 
+#ifndef __BSD__
 #include <endian.h>
+#endif 
 #include <stdio.h>
 #include <sys/types.h>
Index: trunk/src/libctests/glibc/inet/test-ifaddrs.c
===================================================================
--- trunk/src/libctests/glibc/inet/test-ifaddrs.c	(revision 2045)
+++ trunk/src/libctests/glibc/inet/test-ifaddrs.c	(revision 2046)
@@ -22,4 +22,8 @@
 #include <stdlib.h>
 #include <string.h>
+#ifdef __BSD__
+# include <sys/types.h>
+# include <sys/socket.h>
+#endif 
 #include <ifaddrs.h>
 #include <netinet/in.h>
Index: trunk/src/libctests/glibc/inet/test_ifindex.c
===================================================================
--- trunk/src/libctests/glibc/inet/test_ifindex.c	(revision 2045)
+++ trunk/src/libctests/glibc/inet/test_ifindex.c	(revision 2046)
@@ -23,4 +23,8 @@
 #include <stdlib.h>
 #include <string.h>
+#ifdef __BSD__
+# include <sys/types.h>
+# include <sys/socket.h>
+#endif 
 #include <net/if.h>
 
Index: trunk/src/libctests/glibc/inet/tst-ntoa.c
===================================================================
--- trunk/src/libctests/glibc/inet/tst-ntoa.c	(revision 2045)
+++ trunk/src/libctests/glibc/inet/tst-ntoa.c	(revision 2046)
@@ -1,4 +1,8 @@
 #include <stdio.h>
 #include <string.h>
+#ifdef __BSD__
+# include <sys/types.h>
+# include <sys/socket.h>
+#endif 
 #include <arpa/inet.h>
 #include <netinet/in.h>