Index: trunk/src/emx/testcase/misc/alloca-1.c
===================================================================
--- trunk/src/emx/testcase/misc/alloca-1.c	(revision 2051)
+++ 	(revision )
@@ -1,139 +1,0 @@
-/* $Id$ */
-/** @file
- *
- * alloca testcase.
- *
- * Copyright (c) 2005 knut st. osmundsen <bird@anduin.net>
- *
- *
- * This file is part of InnoTek LIBC.
- *
- * InnoTek LIBC is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published
- * by the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * InnoTek LIBC is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with InnoTek LIBC; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- *
- */
-
-
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
-#include <stdio.h>
-#include <stdlib.h>
-#include <string.h>
-
-
-/*******************************************************************************
-*   Global Variables                                                           *
-*******************************************************************************/
-/** Array with sizes to alloca. */
-static const size_t g_acb[] =
-{
-    0,
-    1,
-    2,
-    3,
-    4,
-    5,
-    6,
-    7,
-    8,
-    0,
-    9,
-    10,
-    11,
-    12,
-    13,
-    14,
-    15,
-    16,
-    17,
-    18,
-    19,
-    20,
-    21,
-    22,
-    23,
-    24,
-    25,
-    26,
-    27,
-    28,
-    29,
-    31,
-    32,
-    33,
-    1,
-    127,
-    128,
-    0,
-    129,
-    130,
-    131,
-    132,
-    133,
-    256,
-    2047,
-    2048,
-    2049,
-    4090,
-    4095,
-    4096,
-    4097,
-    8192,
-    16384,
-    32763,
-    32767,
-    32768,
-    32774
-};
-
-
-static int verify(void *pv, int ch, size_t cb)
-{
-    size_t cbLeft = cb;
-    char *pch;
-    for (pch = (char *)pv; cbLeft > 0; cbLeft--, pch++)
-        if (*pch != ch)
-        {
-            printf("alloca: FAILURE - ch=%d *pch=%d cb=%d off=%d\n", ch, *pch, cb, pch - (char *)pv);
-            return 1;
-        }
-    return 0;
-}
-
-
-int main()
-{
-    void   *apv[sizeof(g_acb) / sizeof(g_acb[0])] = {0};
-    int     rcRet = 0;
-    int     i;
-    for (i = 0; i < sizeof(g_acb) / sizeof(g_acb[0]); i++)
-    {
-        apv[i] = alloca(g_acb[i]);
-        memset(apv[i], i, g_acb[i]);
-        verify(apv[i], i, g_acb[i]);
-        if (i > 0)
-            verify(apv[i - 1], i - 1, g_acb[i - 1]);
-    }
-
-    for (i = 0; i < sizeof(g_acb) / sizeof(g_acb[0]); i++)
-        rcRet += verify(apv[i], i, g_acb[i]);
-
-    if (!rcRet)
-        printf("alloca: SUCCESS\n");
-    else
-        printf("alloca: FAILURE - %d errors\n", rcRet);
-
-    return !!rcRet;
-}
Index: trunk/src/emx/testcase/misc/fork-1.c
===================================================================
--- trunk/src/emx/testcase/misc/fork-1.c	(revision 2051)
+++ 	(revision )
@@ -1,27 +1,0 @@
-#define INCL_BASE
-#include <os2.h>
-#include <stdio.h>
-#include <unistd.h>
-
-int main(int argc, char **argv) {
-    int i;
-    for (i=0; i<10000; i++) {
-        int pid = fork();
-        switch (pid) {
-        case -1:
-            printf("Error\n");
-            break;
-        case 0:
-            printf("I'm child %#x i=%d.\n", getpid(), i);
-            exit(0);
-            break;
-
-            default:
-            //if (!(i % 10))
-            //    printf("forked %#x i=%d\n", pid, i);
-            //DosSleep(2);
-            break;
-        }
-    }
-    return 0;
-}
Index: trunk/src/emx/testcase/misc/open-1.c
===================================================================
--- trunk/src/emx/testcase/misc/open-1.c	(revision 2051)
+++ 	(revision )
@@ -1,62 +1,0 @@
-/* $Id$ */
-/** @file
- *
- * Simple open() testcase.
- *
- * Copyright (c) 2004 knut st. osmundsen <bird@anduin.net>
- *
- *
- * This file is part of InnoTek LIBC.
- *
- * InnoTek LIBC is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published
- * by the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * InnoTek LIBC is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with InnoTek LIBC; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- *
- */
-
-
-#include <unistd.h>
-#include <stdio.h>
-#include <errno.h>
-#include <sys/fcntl.h>
-
-int main()
-{
-    int fh = open("/dev/null", O_RDWR);
-    if (fh < 0)
-    {
-        printf("open-1: FAILURE - errno=%d\n", errno);
-        return 1;
-    }
-    close(fh);
-
-    fh = open("/dev/null", O_RDONLY);
-    if (fh < 0)
-    {
-        printf("open-1: FAILURE - O_RD errno=%d\n", errno);
-        return 1;
-    }
-    close(fh);
-
-    fh = open("/dev/null", O_WRONLY);
-    if (fh < 0)
-    {
-        printf("open-1: FAILURE - O_WR errno=%d\n", errno);
-        return 1;
-    }
-    close(fh);
-
-    printf("open-1: SUCCESS\n");
-    return 0;
-}
-
Index: trunk/src/emx/testcase/misc/opendir-1.c
===================================================================
--- trunk/src/emx/testcase/misc/opendir-1.c	(revision 2051)
+++ 	(revision )
@@ -1,60 +1,0 @@
-#include <dirent.h>
-#include <stdio.h>
-#include <errno.h>
-
-int main(int argc, char **argv)
-{
-    DIR    *pDir;
-    int     rc = 0;
-    printf("opendir-1: TESTING\n");
-
-    errno = 4242;
-    pDir = opendir(".");
-    if (pDir)
-        closedir(pDir);
-    else
-    {
-        printf("failed to open '.'. errno=%d\n", errno);
-        rc++;
-    }
-
-    errno = 4242;
-    pDir = opendir("./");
-    if (pDir)
-        closedir(pDir);
-    else
-    {
-        printf("failed to open './'. errno=%d\n", errno);
-        rc++;
-    }
-
-    errno = 4242;
-    pDir = opendir(".//");
-    if (pDir)
-        closedir(pDir);
-    else
-    {
-        printf("failed to open './/'. errno=%d\n", errno);
-        rc++;
-    }
-
-    errno = 4242;
-    pDir = opendir("/");
-    if (pDir)
-        closedir(pDir);
-    else
-    {
-        printf("failed to open '/'. errno=%d\n", errno);
-        rc++;
-    }
-
-
-    /*
-     * Summary.
-     */
-    if (rc)
-        printf("opendir-1: FAILURE %d failures\n", rc);
-    else
-        printf("opendir-1: SUCCESS\n");
-    return rc;
-}
Index: trunk/src/emx/testcase/misc/stat-1.c
===================================================================
--- trunk/src/emx/testcase/misc/stat-1.c	(revision 2051)
+++ 	(revision )
@@ -1,54 +1,0 @@
-#include <unistd.h>
-#include <sys/stat.h>
-#include <stdio.h>
-#include <errno.h>
-
-
-int main(int argc, char **argv)
-{
-    int             cErrors = 0;
-    int             rc;
-    struct stat     s;
-    printf("stat-1: TESTING\n");
-
-
-    /*
-     * Current dir.
-     */
-    rc = stat(".", &s);
-    if (rc != 0)
-    {
-        printf("stat(%s) -> %d errno=%d\n", ".", rc, errno);
-        cErrors++;
-    }
-
-    /*
-     * Parent dir.
-     */
-    rc = stat("..", &s);
-    if (rc != 0)
-    {
-        printf("stat(%s) -> %d errno=%d\n", "..", rc, errno);
-        cErrors++;
-    }
-
-
-    /*
-     * Executable.
-     */
-    rc = stat(argv[0], &s);
-    if (rc != 0)
-    {
-        printf("stat(%s) -> %d errno=%d\n", argv[0], rc, errno);
-        cErrors++;
-    }
-
-    /*
-     * Summary.
-     */
-    if (cErrors)
-        printf("stat-1: FAILURE %d failures\n", cErrors);
-    else
-        printf("stat-1: SUCCESS\n");
-    return cErrors;
-}
Index: trunk/src/emx/testcase/misc/waitpid-1.c
===================================================================
--- trunk/src/emx/testcase/misc/waitpid-1.c	(revision 2051)
+++ 	(revision )
@@ -1,157 +1,0 @@
-/* $Id$ */
-/** @file
- *
- * waitpid-1
- *
- * Copyright (c) 2004 knut st. osmundsen <bird@anduin.net>
- *
- *
- * This file is part of InnoTek LIBC.
- *
- * InnoTek LIBC is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published
- * by the Free Software Foundation; either version 2 of the License, or
- * (at your option) any later version.
- *
- * InnoTek LIBC is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with InnoTek LIBC; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- *
- */
-
-
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
-#include <sys/wait.h>
-#include <unistd.h>
-#include <string.h>
-#include <stdio.h>
-#include <errno.h>
-#include <process.h>
-#include <signal.h>
-
-/*******************************************************************************
-*   Global Variables                                                           *
-*******************************************************************************/
-volatile pid_t g_pid0 = -1;
-volatile pid_t g_pid1 = -1;
-volatile pid_t g_pid64 = -1;
-volatile pid_t g_pid128 = -1;
-volatile pid_t g_pidKill = -1;
-volatile int   g_cErrors = 0;
-volatile int   g_cReaped = 0;
-
-static void sigchild(int iSignal)
-{
-    int     rc;
-    pid_t   pid;
-    while ((pid = waitpid(-1, &rc, WNOHANG)) > 0)
-    {
-        g_cReaped++;
-        printf("waitpid-1: info - reaped %#x rc=%d\n", pid, rc);
-        int rcWanted = -1;
-        if (pid == g_pid0)
-            rcWanted = W_EXITCODE(0,0);
-        else if (pid == g_pid1)
-            rcWanted = W_EXITCODE(1, 0);
-        else if (pid == g_pid64)
-            rcWanted = W_EXITCODE(64, 0);
-        else if (pid == g_pid128)
-            rcWanted = W_EXITCODE(128, 0);
-        else if (pid == g_pidKill)
-            rcWanted = W_EXITCODE(0, SIGKILL);
-        else
-        {
-            printf("waitpid-1: WARNING - interrupted before spawn returned!?!\n");
-            continue;
-        }
-        if (rc != rcWanted)
-        {
-            printf("waitpid-1: ERROR - pid=%#x exitted with rc=%#x expected %#x\n", pid, rc, rcWanted);
-            g_cErrors++;
-        }
-    }
-}
-
-int main(int argc, char **argv)
-{
-    /*
-     * Child for child.
-     */
-    if (argc == 2)
-    {
-        usleep(1000);
-        if (!strcmp(argv[1], "child-1"))
-            return 1;
-        if (!strcmp(argv[1], "child-64"))
-            return 64;
-        if (!strcmp(argv[1], "child-128"))
-            return 128;
-        if (!strcmp(argv[1], "child-kill"))
-            sleep(24*60*60);
-        return 0;
-    }
-
-    struct sigaction sigact;
-    sigact.sa_handler = sigchild;
-    sigact.sa_flags = 0;
-    sigemptyset(&sigact.sa_mask);
-    if (sigaction(SIGCHLD, &sigact, NULL))
-    {
-        printf("waitpid-1: ERROR - sigaction failed. errno=%d\n", errno);
-        return 1;
-    }
-
-    /*
-     * spawn children.
-     */
-    sighold(SIGCHLD);
-    g_pid0 = spawnl(P_NOWAIT, argv[0], argv[0], "child", NULL);
-    g_pid1 = spawnl(P_NOWAIT, argv[0], argv[0], "child-1", NULL);
-    g_pid64 = spawnl(P_NOWAIT, argv[0], argv[0], "child-64", NULL);
-    g_pid128 = spawnl(P_NOWAIT, argv[0], argv[0], "child-128", NULL);
-    g_pidKill = spawnl(P_NOWAIT, argv[0], argv[0], "child-kill", NULL);
-    int cSpawned = (g_pid0 > 0)
-                 + (g_pid1 > 0)
-                 + (g_pid64 > 0)
-                 + (g_pid128 > 0)
-                 + (g_pidKill > 0);
-    printf("waitpid-1: info - pid0=%#x pid1=%#x pid64=%#x pid128=%#x pidKill=%#x\n", g_pid0, g_pid1, g_pid64, g_pid128, g_pidKill);
-    if (cSpawned != 5)
-    {
-        printf("waitpid-1: ERROR - one or more spawns failed. cSpawned=%d should be 5!\n", cSpawned);
-        g_cErrors++;
-    }
-    sigrelse(SIGCHLD);
-
-    int cWaits = 0;
-    while (g_cReaped < cSpawned && cWaits++ < 30)
-    {
-        if (cWaits == 1 && g_cReaped + 1 == cSpawned)
-            kill(g_pidKill, SIGKILL);
-        else
-        {
-            sleep(1);
-            kill(g_pidKill, SIGKILL);
-        }
-    }
-
-    if (g_cReaped != cSpawned)
-    {
-        printf("waitpid-1: ERROR - reaped %d spawned %d!\n", g_cReaped, cSpawned);
-        g_cErrors++;
-    }
-
-    if (!g_cErrors)
-        printf("waitpid-1: SUCCESS\n");
-    else
-        printf("waitpid-1: FAILED - %d errors\n", g_cErrors);
-
-    return !!g_cErrors;
-}
Index: trunk/src/emx/testcase/misc/wctype-1.c
===================================================================
--- trunk/src/emx/testcase/misc/wctype-1.c	(revision 2051)
+++ 	(revision )
@@ -1,20 +1,0 @@
-#include <wctype.h>
-#include <ctype.h>
-#include <stdio.h>
-#include <locale.h>
-
-int main()
-{
-    int rc = 0;
-    if (!setlocale(LC_ALL, "C"))
-    {
-        printf("setlocale failed!\n");
-        return 1;
-    }
-    printf("iscntrl(0x82) -> %d\n", iscntrl(0x82));
-    printf("iswcntrl(0x82) -> %d\n", iswcntrl(0x82));
-    if (!!iscntrl(0x82) != !!iswcntrl(0x82))
-        printf("!!iscntrl(0x82) != !!iswcntrl(0x82) - behaviour isn't specified afaik, just checking.\n");
-    return rc;
-}
-