Index: /trunk/kBuild/tools/OPENWATCOM-16.kmk
===================================================================
--- /trunk/kBuild/tools/OPENWATCOM-16.kmk	(revision 2068)
+++ /trunk/kBuild/tools/OPENWATCOM-16.kmk	(revision 2069)
@@ -41,5 +41,20 @@
 TOOL_OPENWATCOM-16_LDFLAGS.win  ?= -bt=windows
 
-							
+
+TOOL_OPENWATCOM-16_COMPILE_AS_DEPEND =
+TOOL_OPENWATCOM-16_COMPILE_AS_DEPORD =
+TOOL_OPENWATCOM-16_COMPILE_AS_OUTPUT = $(obj).err
+define TOOL_OPENWATCOM-16_COMPILE_AS_CMDS
+	$(QUIET) $(call TOOL_OPENWATCOM_ENV_SETUP) $(TOOL_OPENWATCOM_CC16) \
+		$(flags) \
+		$(addsuffix , $(addprefix -i=, $(subst /,\\,$(incs)))) \
+		$(addprefix -d, $(defs)) \
+		-fo=$(subst /,\\,$(obj)) \
+		-fr=$(subst /,\\,$(obj)).err \
+		$(subst /,\\,$(abspath $(source)))
+	$(QUIET)$(APPEND) -n $(obj).err
+## @todo dependencies	
+endef
+
 TOOL_OPENWATCOM-16_COMPILE_C_DEPEND =
 TOOL_OPENWATCOM-16_COMPILE_C_DEPORD =
@@ -85,14 +100,10 @@
 endef
 
-TOOL_OPENWATCOM-16_LINK_LIBRARY_OUTPUT = ## @todo $(outbase).rsp
+TOOL_OPENWATCOM-16_LINK_LIBRARY_OUTPUT = $(outbase).rsp
 TOOL_OPENWATCOM-16_LINK_LIBRARY_DEPEND = $(othersrc)
 TOOL_OPENWATCOM-16_LINK_LIBRARY_DEPORD =
 define TOOL_OPENWATCOM-16_LINK_LIBRARY_CMDS
-	$(if $(strip $(othersrc)),\
-		$(QUIET)$(TOOL_OPENWATCOM_ENV_SETUP) \
-		$(TOOL_OPENWATCOM_IMP) $(TOOL_OPENWATCOM_IMPFLAGS) $(subst /,\\,$(out)) $(subst /,\\,$(othersrc)) )
-	$(if $(strip $(objs)),$(QUIET)$(TOOL_OPENWATCOM_ENV_SETUP) \
-		$(QUIET)$(TOOL_OPENWATCOM_ENV_SETUP) \
-		$(TOOL_OPENWATCOM_AR) $(flags) $(subst /,\\,$(out)) $(foreach obj,$(subst /,\\,$(objs)),+"$(obj)") ";" )
+	$(QUIET)$(APPEND) -tn $(outbase).rsp $(foreach obj,$(subst /,\,$(objs) $(othersrc)),'+"$(obj)"')
+	$(QUIET)$(TOOL_OPENWATCOM_ENV_SETUP) $(TOOL_OPENWATCOM_AR) $(flags) $(subst /,\\,$(out)) @$(outbase).rsp
 endef
 
Index: /trunk/kBuild/tools/OPENWATCOM.kmk
===================================================================
--- /trunk/kBuild/tools/OPENWATCOM.kmk	(revision 2068)
+++ /trunk/kBuild/tools/OPENWATCOM.kmk	(revision 2069)
@@ -103,12 +103,14 @@
 							
 # General Properties used by kBuild
+TOOL_OPENWATCOM_ASOBJSUFF         ?= .obj
+TOOL_OPENWATCOM_ASFLAGS           ?= -zq
+TOOL_OPENWATCOM_ASFLAGS.os2       ?= -bt=os2
+TOOL_OPENWATCOM_ASFLAGS.win       ?= -bt=nt
+
 TOOL_OPENWATCOM_COBJSUFF         ?= .obj
 TOOL_OPENWATCOM_CFLAGS           ?= -zq
 TOOL_OPENWATCOM_CFLAGS.os2       ?= -bt=os2
 TOOL_OPENWATCOM_CFLAGS.win       ?= -bt=nt
-TOOL_OPENWATCOM_CFLAGS.debug     ?=
-TOOL_OPENWATCOM_CFLAGS.release   ?=
 TOOL_OPENWATCOM_CINCS            ?= $(PATH_TOOL_OPENWATCOM)/h
-TOOL_OPENWATCOM_CDEFS            ?=
 
 TOOL_OPENWATCOM_CXXOBJSUFF       ?= .obj
@@ -116,8 +118,5 @@
 TOOL_OPENWATCOM_CXXFLAGS.os2     ?= -bt=os2
 TOOL_OPENWATCOM_CXXFLAGS.win     ?= -bt=nt
-TOOL_OPENWATCOM_CXXFLAGS.debug   ?=
-TOOL_OPENWATCOM_CXXFLAGS.release ?=
 TOOL_OPENWATCOM_CXXINCS          ?= $(PATH_TOOL_OPENWATCOM)/h
-TOOL_OPENWATCOM_CXXDEFS          ?=
 
 TOOL_OPENWATCOM_RCOBJSUFF        ?= .res
@@ -126,5 +125,4 @@
 TOOL_OPENWATCOM_RCFLAGS.win      ?= -bt=nt
 TOOL_OPENWATCOM_RCINCS           ?= $(PATH_TOOL_OPENWATCOM)/h
-TOOL_OPENWATCOM_RCDEFS           ?=
 
 TOOL_OPENWATCOM_ARFLAGS          ?=
@@ -134,7 +132,22 @@
 TOOL_OPENWATCOM_LDFLAGS.os2      ?= -bt=os2
 TOOL_OPENWATCOM_LDFLAGS.win      ?= -bt=nt
-TOOL_OPENWATCOM_LDFLAGS.debug    ?=
-
-
+
+
+TOOL_OPENWATCOM_COMPILE_AS_DEPEND =
+TOOL_OPENWATCOM_COMPILE_AS_DEPORD =
+TOOL_OPENWATCOM_COMPILE_AS_OUTPUT = $(obj).err
+define TOOL_OPENWATCOM_COMPILE_AS_CMDS
+	$(QUIET) $(call TOOL_OPENWATCOM_ENV_SETUP) $(TOOL_OPENWATCOM_AS) \
+		$(flags) \
+		$(addsuffix , $(addprefix -i=, $(subst /,\\,$(incs)))) \
+		$(addprefix -d, $(defs)) \
+		-fo=$(subst /,\\,$(obj)) \
+		-fr=$(subst /,\\,$(obj)).err \
+		$(subst /,\\,$(abspath $(source)))
+	$(QUIET)$(APPEND) -n $(obj).err
+## @todo dependencies	
+endef
+
+										  
 TOOL_OPENWATCOM_COMPILE_C_DEPEND =
 TOOL_OPENWATCOM_COMPILE_C_DEPORD =
@@ -184,10 +197,6 @@
 TOOL_OPENWATCOM_LINK_LIBRARY_DEPORD =
 define TOOL_OPENWATCOM_LINK_LIBRARY_CMDS
-	$(if $(strip $(othersrc)),\
-		$(QUIET)$(TOOL_OPENWATCOM_ENV_SETUP) \
-		$(TOOL_OPENWATCOM_IMP) $(TOOL_OPENWATCOM_IMPFLAGS) $(subst /,\\,$(out)) $(subst /,\\,$(othersrc)) )
-	$(if $(strip $(objs)),$(QUIET)$(TOOL_OPENWATCOM_ENV_SETUP) \
-		$(QUIET)$(TOOL_OPENWATCOM_ENV_SETUP) \
-		$(TOOL_OPENWATCOM_AR) $(flags) $(subst /,\\,$(out)) $(foreach obj,$(subst /,\\,$(objs)),+"$(obj)") ";" )
+	$(QUIET)$(APPEND) -tn $(outbase).rsp $(foreach obj,$(subst /,\,$(objs) $(othersrc)),'+"$(obj)"')
+	$(QUIET)$(TOOL_OPENWATCOM_ENV_SETUP) $(TOOL_OPENWATCOM_AR) $(flags) $(subst /,\\,$(out)) @$(outbase).rsp
 endef
 
Index: /trunk/kBuild/tools/WATCOMC11C-16.kmk
===================================================================
--- /trunk/kBuild/tools/WATCOMC11C-16.kmk	(revision 2068)
+++ /trunk/kBuild/tools/WATCOMC11C-16.kmk	(revision 2069)
@@ -88,10 +88,6 @@
 TOOL_WATCOMC11C-16_LINK_LIBRARY_DEPORD =
 define TOOL_WATCOMC11C-16_LINK_LIBRARY_CMDS
-	$(if $(strip $(othersrc)),\
-		$(QUIET)$(TOOL_WATCOMC11C_ENV_SETUP) \
-		$(TOOL_WATCOMC11C_IMP) $(TOOL_WATCOMC11C_IMPFLAGS) $(subst /,\\,$(out)) $(subst /,\\,$(othersrc)) )
-	$(if $(strip $(objs)),$(QUIET)$(TOOL_WATCOMC11C_ENV_SETUP) \
-		$(QUIET)$(TOOL_WATCOMC11C_ENV_SETUP) \
-		$(TOOL_WATCOMC11C_AR) $(flags) $(subst /,\\,$(out)) $(foreach obj,$(subst /,\\,$(objs)),+"$(obj)") ";" )
+	$(QUIET)$(APPEND) -tn $(outbase).rsp $(foreach obj,$(subst /,\,$(objs) $(othersrc)),'+"$(obj)"')
+	$(QUIET)$(TOOL_WATCOMC11C_ENV_SETUP) $(TOOL_WATCOMC11C_AR) $(flags) $(subst /,\\,$(out)) @$(outbase).rsp
 endef
 
Index: /trunk/kBuild/tools/WATCOMC11C.kmk
===================================================================
--- /trunk/kBuild/tools/WATCOMC11C.kmk	(revision 2068)
+++ /trunk/kBuild/tools/WATCOMC11C.kmk	(revision 2069)
@@ -180,14 +180,10 @@
 endef
 
-TOOL_WATCOMC11C_LINK_LIBRARY_OUTPUT = ## @todo $(outbase).rsp
+TOOL_WATCOMC11C_LINK_LIBRARY_OUTPUT = $(outbase).rsp
 TOOL_WATCOMC11C_LINK_LIBRARY_DEPEND = $(othersrc)
 TOOL_WATCOMC11C_LINK_LIBRARY_DEPORD =
 define TOOL_WATCOMC11C_LINK_LIBRARY_CMDS
-	$(if $(strip $(othersrc)),\
-		$(QUIET)$(TOOL_WATCOMC11C_ENV_SETUP) \
-		$(TOOL_WATCOMC11C_IMP) $(TOOL_WATCOMC11C_IMPFLAGS) $(subst /,\\,$(out)) $(subst /,\\,$(othersrc)) )
-	$(if $(strip $(objs)),$(QUIET)$(TOOL_WATCOMC11C_ENV_SETUP) \
-		$(QUIET)$(TOOL_WATCOMC11C_ENV_SETUP) \
-		$(TOOL_WATCOMC11C_AR) $(flags) $(subst /,\\,$(out)) $(foreach obj,$(subst /,\\,$(objs)),+"$(obj)") ";" )
+	$(QUIET)$(APPEND) -tn $(outbase).rsp $(foreach obj,$(subst /,\,$(objs) $(othersrc)),'+"$(obj)"')
+	$(QUIET)$(TOOL_WATCOMC11C_ENV_SETUP) $(TOOL_WATCOMC11C_AR) $(flags) $(subst /,\\,$(out)) @$(outbase).rsp
 endef
 